import express from "express"
import mongoose from "mongoose"
import passport from "passport"
import bodyParser from "body-parser"
import { db } from "./db.mjs"
import { default as routes } from "./routes/routes.mjs"
import { default as secureRoute } from "./routes/secure-routes.mjs"
import "./auth/auth.mjs"
mongoose.connect("mongodb://127.0.0.1:27017/passport-jwt", {});
mongoose.connection.on('error', error => console.log(error));
mongoose.Promise = global.Promise;

const app = express()
app.use(passport.initialize())

app.use(bodyParser.json())
app.use("/", routes)
app.use('/user', passport.authenticate('jwt', { session: false }), secureRoute);

// Handle errors.
app.use(function(err: any, req: any, res: any, next: any) {
	res.status(err.status || 500);
	res.json({ error: err });
});

app.listen(3000, () => {
	console.log('Server started.')
});
